import json

from ..controller.generators import (
    get_generator,
    get_generators,
    add_generator,
    update_generator,
    generate_needed_things,
)
from .editor import ( TableEditor, )


class GenEditor(TableEditor):
    def __init__(self):
        super().__init__()
        self.update_item_callback = update_generator
        self.add_item_callback = add_generator
        self.get_item_callback = get_generator
        self.table_config = self._load_config("recurring")

    def refresh_items(self):
        generated = generate_needed_things()
        if num := len(generated):
            self.notify(f"created {num} things")
        items = get_generators()
        for item in items:
            self.table.add_row(
                str(item.id),
                item.template,
                item.type,
                json.loads(item.config)["val"],
                str(item.next_at()),
            )


def run():
    app = GenEditor()
    app.run()
